/**
 * @license
 * Copyright 2017 JBoss Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ChangeDetectorRef, EventEmitter } from "@angular/core";
import { DropDownOption } from '../../../../../../../components/common/drop-down.component';
import { CommandService } from "../../../_services/command.service";
import { DocumentService } from "../../../_services/document.service";
import { SelectionService } from "../../../_services/selection.service";
import { AbstractRowComponent } from "../../common/item-row.abstract";
import { Oas20Schema, Oas30Schema, SimplifiedParameterType, SimplifiedPropertyType, SimplifiedType } from "apicurio-data-models";
import Oas20PropertySchema = Oas20Schema.Oas20PropertySchema;
import Oas30PropertySchema = Oas30Schema.Oas30PropertySchema;
export declare class PropertyRowComponent extends AbstractRowComponent<Oas20PropertySchema | Oas30PropertySchema, SimplifiedPropertyType> {
    private commandService;
    onDelete: EventEmitter<void>;
    onRename: EventEmitter<void>;
    _ptab: string;
    /**
     * C'tor.
     * @param changeDetectorRef
     * @param documentService
     * @param commandService
     * @param selectionService
     */
    constructor(changeDetectorRef: ChangeDetectorRef, documentService: DocumentService, commandService: CommandService, selectionService: SelectionService);
    protected updateModel(): void;
    isParameter(): boolean;
    hasDescription(): boolean;
    hasType(): boolean;
    description(): string;
    example(): string;
    minimum(): number;
    maximum(): number;
    isRequired(): boolean;
    required(): string;
    requiredOptions(): DropDownOption[];
    minimumIsSet(): string | null;
    maximumIsSet(): string | null;
    multipleOfIsSet(): string | null;
    minItemsIsSet(): string | null;
    maxItemsIsSet(): string | null;
    minLengthIsSet(): string | null;
    maxLengthIsSet(): string | null;
    exclusiveMinIsSet(): boolean | null;
    uniqueItemsIsSet(): boolean | null;
    readOnlyIsSet(): boolean | null;
    writeOnlyIsSet(): boolean | null;
    minPropertiesIsSet(): string | null;
    maxPropertiesIsSet(): string | null;
    exclusiveMaxIsSet(): boolean | null;
    isEditingDescription(): boolean;
    isEditingSummary(): boolean;
    isEditingExample(): boolean;
    isIntFloatEligible(): boolean;
    isStringEligible(): boolean;
    isArrayEligible(): boolean;
    toggleDescription(): void;
    toggleSummary(): void;
    toggleExample(): void;
    delete(): void;
    displayType(): SimplifiedParameterType;
    rename(): void;
    setDescription(description: string): void;
    setExample(example: string): void;
    setNumValue(val: string, name: string): void;
    setArrayValue(val: string, name: string): void;
    setPattern(pattern: string): void;
    changeRequired(newValue: string): void;
    changeType(newType: SimplifiedType): void;
    setBoolean(val: boolean, name: string): void;
}
